#if !defined( _JVizObjectObj_h )
#define _JVizObjectObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JVizObjectObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      TRANSPARENCY,
      X,
      Y,
      Z,
      RED,
      GREEN,
      BLUE,
      XSCALE,
      YSCALE,
      ZSCALE,
      SCALE,
      ROTATION,
      EXT_1,
      EXT_2,
      EXT_3,
      EXT_4,
      EXT_5 };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JVizObjectObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int outputType( int n );
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

    // inputs
    int transparency;
    int x;
    int y;
    int z;
    int red;
    int green;
    int blue;
    int xscale;
    int yscale;
    int zscale;
    int scale;
    int rotation;
    int ext_1;
    int ext_2;
    int ext_3;
    int ext_4;
    int ext_5;

    // properties
    JString viz_name;
    JString ext_1p;
    JString ext_2p;
    JString ext_3p;
    JString ext_4p;
    JString ext_5p;

    // outputs
    JString result;
};


#endif
